/*

(C) 2000, Ȳ ġ(hwang@mizi.co.kr)

Ϻ ƾ Դ HanXκ ̵ ų 
ڵ带 ߽ϴ.
(C) 1999, Oh, SungKyu(hanmaum@sparcs.kaist.ac.kr)

HanOut:
    FontSet ̿ʴ X Toolkit ѱ   ֵ
    ִ Subroutine. 
     X library ϴ  ̿Ͽ ּ 
     ѱ µ ǹ̸ ξϴ.

    HanX ٸ : 
	Է,  ۲,  ۲ ʴ´.
	Scalable Hangul Font ݵ  ־մϴ.
	Display   α׷( ׷ α׷
	   ϴ.)   ϴ.
	FontSet ϴ ƾ 浹 ߴ.
	Drawing ؼ FontSet ̿Ѵ.
    :
	ҽ Ǿ ȭ Ǿʴ ̺귯
	  ѱ ʴ α׷ :
	    lyxͰ α׷ ̿ شմϴ.   α׷
	       ũŰ° մϴ. 
	 ̳ʸ ϰ ȭ Ǿʴ α׷:
	    rvplayer mxaudio  α׷ ѱ Ҷ
	    gcc -shared -o hanout.so -I/usr/X11R6/include hanout.c -L/usr/X11R6/lib -lX11 -ldl
	     hanout.so  ̸ /usr/lib/  ֽϴ.
	    ׷  ϴ α׷ Ͻ  LD_PRELOAD=hanout.so program
	    ̷ ϸ ˴ϴ.
	 ҽ Ǿ ȭ ȵǾִ :
	    ҽ  ġô° ξ ϴ.

** Last modified: 2000/01/31

*/

#include <stdlib.h>
#include <locale.h>
#include <stdio.h>
#include <dlfcn.h>
#include <string.h>
#include <malloc.h>
#include <assert.h>
#include <X11/Xlib.h>
#include <X11/Xlibint.h>

#define WRAP_WIDTH 1

static int debug = 0;

typedef struct _FontSetList FontSetList;
struct _FontSetList {
    FontSetList *next;
    FontSetList *prev;
    Font fid;
    XFontSet fontset;
} _FontSetList;

typedef struct font_name_list {
    char *name;
    struct font_name_list *next;
} font_name_list;

font_name_list *first_item = (font_name_list *)0;

static int
add_font_name_list (char *fname) {
    font_name_list *tmp;
    extern font_name_list *first_item;

    tmp = (font_name_list *)malloc(sizeof(font_name_list));

    if (!tmp) { return 0; }		// mem alloc failed

    tmp->name = (char *)malloc(strlen(fname) + 1);

    if (!tmp->name) {
	free(tmp);
	return 0;
    }	// mem alloc failed

    strcpy(tmp->name, fname);
    tmp->next = 0;

    if (!first_item) {
	first_item = tmp;
    } else {
	font_name_list *ptr;

	for (ptr=first_item; ptr; ptr=ptr->next) {
	    if (!ptr->next) {
		ptr->next = tmp;
		break;
	    }
	}
    }

    return 1;
}

static char *
choose_best_font(void)
{
    int i;
    font_name_list *ptr;
    static char *best_font[] = {
	"-hanyang-hyrgothic", "-hanyang-hygothic", "-yoondesign-gulim",
	"-yoondesign-batang", "-baekmuk-gulim", "-baekmuk-batang",
	"-hanyang-kodig", "-daewoo-gothic"
    };
    extern font_name_list *first_item;

    for (i=0; i < sizeof(best_font); i++) {
	for (ptr = first_item; ptr; ptr=ptr->next) {
	    if (strstr(ptr->name, best_font[i])) {
		if (debug) { fprintf(stderr, "I've chosen %s\n", ptr->name); }
		return ptr->name;
	    }
	}
    }
    return first_item->name;
}

static int using_fontset = 0;
static FontSetList *fontset_list = NULL;
static void remove_fontset(Display *dpy, Font fid);
static const char * get_fontname(Display *dpy, XFontStruct *fs);

static int (*OrgXDrawString)(Display *, Drawable, GC, int, int, _Xconst char *, int);
static int HackXDrawString(Display *, Drawable, GC, int, int, _Xconst char *, int);
int XDrawString(
    Display *dpy,
    Drawable win,
    GC gc,
    int x, int y,
    _Xconst char *string,
    int length
)
{
    if (using_fontset) 
       return (*OrgXDrawString)(dpy, win, gc, x, y, string, length);
    else
       return HackXDrawString(dpy, win, gc, x, y, string, length);
}

static int (*OrgXDrawImageString)(Display *, Drawable, GC, int, int,_Xconst char *, int);
static int HackXDrawImageString(Display *, Drawable, GC, int, int,_Xconst char *, int);
int XDrawImageString(
    Display *dpy,
    Drawable win,
    GC gc,
    int x, int y,
    _Xconst char *string,
    int length
)
{
    if (using_fontset)
        return (*OrgXDrawImageString)(dpy, win, gc, x, y, string, length);
    else
        return HackXDrawImageString(dpy, win, gc, x, y, string, length);
}

#if WRAP_WIDTH
static int (*OrgXTextExtents)(XFontStruct *, const char *, int, int*, int*, int*, register XCharStruct *);
static int HackXTextExtents(XFontStruct *, const char *, int, int*, int*, int*, register XCharStruct *);
int XTextExtents (
    XFontStruct *fs,
    const char *string,
    int nchars,
    int *dir,           /* RETURN font information */
    int *font_ascent,   /* RETURN font information */
    int *font_descent,  /* RETURN font information */
    register XCharStruct *overall)      /* RETURN character information */
{
    if (using_fontset)
    	return (*OrgXTextExtents)(fs, string, nchars, 
	    dir, font_ascent, font_descent, overall);
    else
    	return HackXTextExtents(fs, string, nchars, 
	    dir, font_ascent, font_descent, overall);
}

static int HackXQueryTextExtents(Display *dpy, Font font, _Xconst char *string,
	int nchar, int *dir, int *ascent, int *descent, XCharStruct *overall);
static int (*OrgXQueryTextExtents)(Display *dpy, Font font, _Xconst char *string,
	int nchar, int *dir, int *ascent, int *descent, XCharStruct *overall);
int XQueryTextExtents(display, font_ID, string, nchars,
     direction_return, font_ascent_return,
     font_descent_return, overall_return)
           Display *display;
           XID font_ID;
           _Xconst char *string;
           int nchars;
           int *direction_return;
           int *font_ascent_return, *font_descent_return;
           XCharStruct *overall_return;
{
    int i;
    if (using_fontset)
    	i = (*OrgXQueryTextExtents)(display, font_ID, string, nchars,
		direction_return, font_ascent_return,
		font_descent_return, overall_return);
   else
    	i = HackXQueryTextExtents(display, font_ID, string, nchars,
		direction_return, font_ascent_return,
		font_descent_return, overall_return);
   return i;
}
#endif

static XFontSet 
find_fontset_matching_fid(Font fid)
{
    FontSetList *list = fontset_list;
    while(list) {
	if (list->fid == fid) {
	    return list->fontset;
	}
	list = list->next;
    }
    return 0;
}

static const char *
get_fontname(Display *dpy, XFontStruct *fs)
{
    Atom fontatom = XInternAtom (dpy, "FONT", False);
    XFontProp *fp;
    int i;
    for (i = 0, fp = fs->properties; i < fs->n_properties; i++, fp++) {
        if (fp->name == fontatom) {
            return (XGetAtomName (dpy, fp->card32));
        }
    }
    return "";
}

const char *
get_next_font_comp(const char *s, char *comp)
{
    while (*s && *s != '-') *comp++ = *s++;
    *comp = 0;
    if (*s) s++;
    return s;
}

static int 
parse_fontname(const char *name, char *fndry, char *fmly, char *wght, 
    char *slant, char *swdth, char *pxlsz, char *ptSz, 
    char *resx, char *resy, char *spc, char *avgWdth, 
    char *rgstry, char *encdng) 
{
    const char *s = name;
    if (*s == '-') s++;
    s = get_next_font_comp(s, fndry);
    if (!*s) return 0;
    s = get_next_font_comp(s, fmly);
    if (!*s) return 0;
    s = get_next_font_comp(s, wght);
    if (!*s) return 0;
    s = get_next_font_comp(s, slant);
    if (!*s) return 0;
    s = get_next_font_comp(s, swdth);
    if (!*s) return 0;
    s = get_next_font_comp(s, pxlsz);
    if (!*s) return 0;
    s = get_next_font_comp(s, pxlsz);
    if (!*s) return 0;
    s = get_next_font_comp(s, ptSz);
    if (!*s) return 0;
    s = get_next_font_comp(s, resx);
    if (!*s) return 0;
    s = get_next_font_comp(s, resy);
    if (!*s) return 0;
    s = get_next_font_comp(s, spc);
    if (!*s) return 0;
    s = get_next_font_comp(s, avgWdth);
    if (!*s) return 0;
    s = get_next_font_comp(s, rgstry);
    if (!*s) return 0;
    s = get_next_font_comp(s, encdng);
    return 1;
}

static char*
find_charset(char *fn_name)
{
    int i;
    char *ptr = fn_name;

    for (i=0; i<13; i++) {	/* 13 is the number of '-' to skip in XLFD notation */
	ptr = strchr(ptr, '-');
	if (!ptr || !(ptr+1)) {
	    return 0;
	} else {
	    ptr = ptr + 1;
	}
    }
    return ptr;
}

static char *
choose_hangul_font_name(Display *dpy)
{
    char **names;
    int num_names;
    int i;
    char *name = 0;
    XFontSet fontset;
    int missing_charset_count;
    char **missing_charset;
    char *def_string;
    char fontlist_name[256];
    XFontStruct **fn_st;
    char **fn_name;
    char *charset;

    if ((name = getenv("HANOUT_FONT"))) return strdup(name);
#ifdef HANOUT_FONT
    return strdup(HANOUT_FONT);
#endif
    /* find correct font charset for this locale */
    fontset = XCreateFontSet(dpy, "*", &missing_charset, &missing_charset_count, &def_string);
    assert (fontset != 0);
    assert (missing_charset_count == 0);
    assert (XFontsOfFontSet(fontset, &fn_st, &fn_name) > 1);

    charset = find_charset(fn_name[1]);

    XFreeFontSet(dpy, fontset);

    sprintf(fontlist_name, "-*-*-*-*-*--*-*-*-*-*-*-ksc5601.1987-0");

    names = XListFonts(dpy, fontlist_name, 
	    1000, &num_names);
    for(i=0;i<num_names;i++) {
	char *s = strstr(names[i], "--");
	if (!s) continue;
	s += 2;

	/* Scalable typefaces have the PixelSize, PointSize set to zero */
	/* I think --0-0- is enough */
	if (strncmp(s, "0-0-", 4) != 0) continue;

	/* I think we need a routine to choose the best font as we can */
	if (strstr(names[i], "talic")  /* italic */
	    || strstr(names[i], "-i-") /* italic */
	    || strstr(names[i], "blique") /* oblique */
	    || strstr(names[i], "-o-") /* oblique */
	    || strstr(names[i], "old")) continue; /* bold */

	add_font_name_list(names[i]);
    }

    XFreeFontNames(names);

    sprintf(fontlist_name, "-*-*-*-*-*--*-*-*-*-*-*-ksx1001.1997-0");

    names = XListFonts(dpy, fontlist_name, 
	    1000, &num_names);
    for(i=0;i<num_names;i++) {
	char *s = strstr(names[i], "--");
	if (!s) continue;
	s += 2;

	/* Scalable typefaces have the PixelSize, PointSize set to zero */
	/* I think --0-0- is enough */
	if (strncmp(s, "0-0-", 4) != 0) continue;

	/* I think we need a routine to choose the best font as we can */
	if (strstr(names[i], "talic")  /* italic */
	    || strstr(names[i], "-i-") /* italic */
	    || strstr(names[i], "blique") /* oblique */
	    || strstr(names[i], "-o-") /* oblique */
	    || strstr(names[i], "old")) continue; /* bold */

	add_font_name_list(names[i]);
    }

    XFreeFontNames(names);

    if (!first_item) {
	//fprintf(stderr, "Sorry, This subroutine requires the scalable hangul fonts\n");
	exit(1);
    }

    /* choose the best font as we can */
    name = choose_best_font();


    return name;
}

static XFontSet
create_matching_fontset(Display *dpy, XFontStruct *fs)
{
    XFontSet fontset = 0;
    char fndry[80], fmly[80], wght[80], slant[80], swdth[80],
        pxlsz[80], ptSz[80], resx[80], resy[80], spc[80], avgWdth[80], 
        rgstry[80], encdng[80];
    const char *name;
    int  missing_charset_count;
    char **missing_charset;
    char *def_string;
    static char *hfndry = 0, *hfmly, *hwght, *hslant, *hwdth, *hpxlsz, *hptSz;
    char hname[256];
    char fullname[256];

    if (!hfndry) {
	char *name = choose_hangul_font_name(dpy);
	parse_fontname(name, fndry, fmly, wght, slant, swdth, pxlsz, 
	    ptSz, resx, resy, spc, avgWdth, rgstry, encdng);
	free(name);
	hfndry = strdup(fndry);
	hfmly = strdup(fmly);
	hwght = strdup(wght);
	hslant = strdup(slant);
	hwdth = strdup(swdth);
	hptSz = "*";
    }

    if (fs->min_byte1 || fs->max_byte1) return 0;

    name = get_fontname(dpy, fs);
    if (!parse_fontname(name, fndry, fmly, wght, slant, swdth, 
        pxlsz, ptSz, resx, resy, spc, avgWdth, rgstry, encdng)) {
	printf("parsing failed: fontname = %s\n", name);
	return fontset;
    }
    hpxlsz = pxlsz;
    sprintf(hname, "-%s-%s-%s-%s-%s--%s-%s-%s-%s-%s-%s-*-*", 
    	hfndry, hfmly, hwght, hslant, hwdth,
	hpxlsz, hptSz, resx, resy, "*", "*");
    sprintf(fullname, "%s,%s", name, hname);
    /*printf("fullanme = %s\n", fullname);*/
    fontset = XCreateFontSet(dpy, fullname, &missing_charset, &missing_charset_count, &def_string);
    if (fontset && missing_charset_count > 0) {
	int i;
	printf("fontset name = %s\n", fullname);
	printf("missing charset\n");
        for (i=0;i<missing_charset_count;i++)
	   printf("    %s\n", missing_charset[i]);
        XFreeStringList (missing_charset);
	XFreeFontSet(dpy, fontset);
	return 0;
    } else if (!fontset) {
	printf("loading failed\n");
    }
    return fontset;
}

static void
adjust_font_struct(XFontStruct *fs, XFontSet fontset)
{
    int hfont_width;
    XFontStruct **fn_st;
    char **fn_name;
    XFontSetExtents *extents;
    extents = XExtentsOfFontSet(fontset);
    fs->ascent = -extents->max_logical_extent.y;
    fs->descent = extents->max_logical_extent.height - fs->ascent;
    assert (XFontsOfFontSet(fontset, &fn_st, &fn_name) > 1);
    hfont_width = fn_st[1]->max_bounds.width;
    if (fs->per_char) {
	int i;
	int max_char = fs->max_char_or_byte2>0xfe?0xfe:fs->max_char_or_byte2;
	for (i=0xa1;i<=max_char;i++) {
	    XCharStruct *cs = &fs->per_char[i-fs->min_char_or_byte2];
	    cs->lbearing = 0;
	    cs->rbearing = hfont_width/2;
	    cs->width = hfont_width/2;
	    cs->ascent = fs->ascent;
	    cs->descent = fs->descent;
	}
    }
}

static void
store_fontset(Font fid, XFontSet fs)
{
    FontSetList *list = (FontSetList *)malloc(sizeof(FontSetList));
    list->fid = fid;
    list->fontset = fs;
    list->next = fontset_list;
    list->prev = NULL;
    if (fontset_list) fontset_list->prev = list;
    fontset_list = list;
}

static void
remove_fontset(Display *dpy, Font fid)
{
    FontSetList *list = fontset_list;
    while(list) {
	if (list->fid == fid) {
	    if (list->next) list->next->prev = list->prev;
	    if (list->prev) list->prev->next = list->next;
	    else fontset_list = list->next;
	    XFreeFontSet(dpy, list->fontset);
	    free(list);
	    return;
	}
	list = list->next;
    }
}

#if WRAP_WIDTH
static int (*OrgXTextWidth)(XFontStruct *, _Xconst char *, int);
static int HackXTextWidth(XFontStruct *, _Xconst char *, int);
int XTextWidth(
    XFontStruct*        fs,
    _Xconst char*       str,
    int                 len
)
{
    if (using_fontset)
    	return (*OrgXTextWidth)(fs, str, len);
    else 
    	return HackXTextWidth(fs, str, len);
}
#endif

static void (*OrgXmbDrawString)(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst char *string, 
	int num_bytes);
void 
XmbDrawString(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst char *string, 
	int num_bytes)
{
    using_fontset++;
    //printf("%s\n",__FUNCTION__);
    (*OrgXmbDrawString)(display, d, font_set, gc, x, y, string, num_bytes);
    using_fontset--;
}

static void (*OrgXwcDrawString)(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst wchar_t *string, 
	int num_wchars);
void 
XwcDrawString(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst wchar_t *string, 
	int num_wchars)
{
    using_fontset++;
    (*OrgXwcDrawString)(display, d, font_set, gc, x, y, string, num_wchars);
    using_fontset--;
}

static void (*OrgXmbDrawImageString)(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst char *string, 
	int num_bytes);
void 
XmbDrawImageString(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst char *string, 
	int num_bytes)
{
    //printf("%s: fontset = %p\n",__FUNCTION__, font_set);
    using_fontset++;
    (*OrgXmbDrawImageString)(display, d, font_set, gc, x, y, string, num_bytes);
    using_fontset--;
}

static void (*OrgXwcDrawImageString)(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst wchar_t *string, 
	int num_wchars);
void 
XwcDrawImageString(Display *display, Drawable d, 
	XFontSet font_set, GC gc, int x, int y, _Xconst wchar_t *string, 
	int num_wchars)
{
    using_fontset++;
    (*OrgXwcDrawImageString)(display, d, font_set, gc, x, y, string, num_wchars);
    using_fontset--;
}
static void (*OrgXFreeFontSet)(Display *display, XFontSet fontset);
void 
XFreeFontSet(Display *display, XFontSet fontset)
{
    using_fontset++;
    (*OrgXFreeFontSet)(display, fontset);
    using_fontset--;
}

static XFontSet (*OrgXCreateFontSet)(Display *display, _Xconst char *base_font_name_list,
     char ***missing_charset_list_return,
     int *missing_charset_count_return,
     char **def_string_return);
XFontSet 
XCreateFontSet(Display *display, _Xconst char *base_font_name_list,
     char ***missing_charset_list_return,
     int *missing_charset_count_return,
     char **def_string_return)
{
    XFontSet fontset;
    //printf("%s\n",__FUNCTION__);
    using_fontset++;
    fontset = (*OrgXCreateFontSet)(display, base_font_name_list,
    	missing_charset_list_return, missing_charset_count_return,
	def_string_return);
    using_fontset--;
    return fontset;
}

#if WRAP_WIDTH
static int
(*OrgXmbTextEscapement)(XFontSet fontset, _Xconst char *string, int len);
int
XmbTextEscapement(XFontSet fontset, _Xconst char *string, int len)
{
    int width;
    //printf("%s\n",__FUNCTION__);
    using_fontset++;
    width = (*OrgXmbTextEscapement)(fontset, string, len);
    using_fontset--;
    return width;
}

static int
(*OrgXwcTextEscapement)(XFontSet fontset, _Xconst wchar_t *string, int len);
int
XwcTextEscapement(XFontSet fontset, _Xconst wchar_t *string, int len)
{
    int width;
    //printf("%s\n",__FUNCTION__);
    using_fontset++;
    width = (*OrgXwcTextEscapement)(fontset, string, len);
    using_fontset--;
    return width;
}
static int (*OrgXmbTextExtents)(XFontSet, _Xconst char *, int, XRectangle *, XRectangle *);
int XmbTextExtents(font_set, string, num_bytes,
     overall_ink_return, overall_logical_return)
           XFontSet font_set;
           _Xconst char *string;
           int num_bytes;
           XRectangle *overall_ink_return;
           XRectangle *overall_logical_return;
{
    int i;
    //printf("%s\n",__FUNCTION__);
    using_fontset++;
    i = (*OrgXmbTextExtents)(font_set, string, num_bytes, overall_ink_return, overall_logical_return);
    using_fontset--;
    return i;
}

static int (*OrgXwcTextExtents)(XFontSet, _Xconst wchar_t *, int, XRectangle *, XRectangle *);
int XwcTextExtents(font_set, string, num_wchars,
     overall_ink_return, overall_logical_return)
           XFontSet font_set;
           _Xconst wchar_t *string;
           int num_wchars;
           XRectangle *overall_ink_return;
           XRectangle *overall_logical_return;
{
    int i;
    //printf("%s\n",__FUNCTION__);
    using_fontset++;
    i = (*OrgXwcTextExtents)(font_set, string, num_wchars, overall_ink_return, overall_logical_return);
    using_fontset--;
    return i;
}

static XFontSetExtents * (*OrgXExtentsOfFontSet)(XFontSet font_set);
XFontSetExtents *
XExtentsOfFontSet(XFontSet font_set)
{
    XFontSetExtents * extents;
    using_fontset++;
    extents = (*OrgXExtentsOfFontSet)(font_set);
    using_fontset--;
    return extents;
}
#endif

static void initialize_fun(Display *dpy, void *handle);

static Display * (*OrgXOpenDisplay)(_Xconst char *display_name);
Display *
XOpenDisplay(_Xconst char *display_name)
{
    void * handle;
    Display *dpy;
    char *s;

    setlocale(LC_ALL, "");
    handle = dlopen("libX11.so", RTLD_LAZY);
    OrgXOpenDisplay = dlsym(handle, "XOpenDisplay");
    dpy = (*OrgXOpenDisplay)(display_name);
    initialize_fun(dpy, handle);
    s = getenv("LD_PRELOAD");
    if (s && strstr(s, "hanout.so")) {
#if HAVE_UNSETENV
	unsetenv ("LD_PRELOAD");
#else
	extern char **environ;
	int i;
	for(i=0;environ[i];i++) {
	    if (strncmp(environ[i], "LD_PRELOAD=", 11) == 0) {
	        char *s = environ[i];
	        for(i=0;i<10;i++) *s++ = 'X';
	        break;
	    }
	}
#endif
    }
    return dpy;
}

static int
HackXDrawString(Display *dpy, Drawable win, 
	GC gc, int x, int y, _Xconst char *string, int length)
{
    XFontSet fs;
    XGCValues gcvalues;
    XGetGCValues(dpy, gc, GCFont, &gcvalues);
    //printf("%s\n",__FUNCTION__);

    fs = find_fontset_matching_fid(gcvalues.font);
    if (fs && length > 1) 
        {
	    XmbDrawString (dpy, win, fs, gc, x, y, string, length);
	    XChangeGC(dpy, gc, GCFont, &gcvalues);
	    //printf("%s: fontset=%p\n",__FUNCTION__,fs);
	    return 1;
	}
    else
	return (*OrgXDrawString)(dpy, win, gc, x, y, string, length);
}

static int
HackXDrawImageString(Display *dpy, Drawable win, GC gc, 
    int x, int y, _Xconst char *string, int length)
{
    XFontSet fs;
    XGCValues gcvalues;
    XGetGCValues(dpy, gc, GCFont, &gcvalues);
    fs = find_fontset_matching_fid(gcvalues.font);
    //printf("%s: fs=%p %s\n",__FUNCTION__, fs, string);
    if (fs && length > 1) {
    	XmbDrawImageString (dpy, win, fs, gc, x, y, string, length);
	XChangeGC(dpy, gc, GCFont, &gcvalues);
	return 1;
    } else
	return (*OrgXDrawImageString)(dpy, win, gc, x, y, string, length);
}

static int
dont_intervene(const char *name)
{
    if (strstr(name, "pecific")) return 1; /* font-specific */
    return 0;
}

static int 
CreateFontHook(Display *dpy, XFontStruct *fs, XExtCodes* code)
{
    XFontSet fontset;
    const char *name;
    if (using_fontset) return 1;
    name = get_fontname(dpy, fs);
    if (dont_intervene(name)) return 1;
    /* printf("%s: %s\n",__FUNCTION__, name);*/
    fontset = create_matching_fontset(dpy, fs);
    if (fontset) {
	store_fontset(fs->fid, fontset);
	adjust_font_struct(fs, fontset);
    }
    return 1;
}

static int 
FreeFontHook(Display *dpy, XFontStruct *fs, XExtCodes* code)
{
    XFontSet fontset;
    if (using_fontset) return 1;
    fontset = find_fontset_matching_fid(fs->fid);
    if (fontset) {
	remove_fontset(dpy, fs->fid);
    }
    return 1;
}

#if WRAP_WIDTH
static int
HackXTextExtents (
    XFontStruct *fs, const char *string,
    int nchars, int *dir, int *font_ascent, int *font_descent,
    register XCharStruct *overall) 
{
    return (*OrgXTextExtents)(fs,string,nchars,dir,font_ascent,font_descent,overall);
#if 0
    fontset = find_fontset_matching_fid(fs->fid);
    if (fontset) { 
        XRectangle  ink, logical;
        XmbTextExtents (fontset, string, nchars, &ink, &logical);
    } else
        (*OrgXTextExtents)(fs,string,nchars,dir,font_ascent,font_descent,overall);
#endif
}

static int 
HackXTextWidth(XFontStruct *font_struct, _Xconst char *string, int len)
{
    XFontSet fontset;
    int width;
    fontset = find_fontset_matching_fid(font_struct->fid);
    if (fontset && len > 1)
       width = XmbTextEscapement (fontset, string, len);
    else 
    	width = (*OrgXTextWidth)(font_struct, string, len);
    //printf("%s: width = %d fontset=%p\n",__FUNCTION__, width, fontset);
    return width;
}

static  int
HackXQueryTextExtents(Display *dpy, Font font, _Xconst char *string,
	int nchars, int *dir, int *ascent, int *descent, XCharStruct *overall)
{
    //printf("%s\n",__FUNCTION__);
    return (*OrgXQueryTextExtents)(dpy, font, string, nchars, dir, ascent, descent,
		overall);
}
#endif

static void
initialize_fun(Display *dpy, void *handle)
{
    XExtCodes *codes = XAddExtension(dpy);
    XESetCreateFont(dpy, codes->extension, CreateFontHook);
    XESetFreeFont(dpy, codes->extension, FreeFontHook);

#if WRAP_WIDTH
    OrgXTextExtents = dlsym(handle, "XTextExtents");
    OrgXQueryTextExtents = dlsym(handle, "XQueryTextExtents");
    OrgXTextWidth = dlsym(handle, "XTextWidth");
#endif

    OrgXDrawString = dlsym(handle, "XDrawString");
    OrgXDrawImageString = dlsym(handle, "XDrawImageString");

    OrgXCreateFontSet = dlsym(handle, "XCreateFontSet");
    OrgXFreeFontSet = dlsym(handle, "XFreeFontSet");
#if WRAP_WIDTH
    OrgXExtentsOfFontSet = dlsym(handle, "XExtentsOfFontSet");
    OrgXmbTextEscapement = dlsym(handle, "XmbTextEscapement");
    OrgXwcTextEscapement = dlsym(handle, "XwcTextEscapement");
    OrgXmbTextExtents = dlsym(handle, "XmbTextExtents");
    OrgXwcTextExtents = dlsym(handle, "XwcTextExtents");
#endif
    OrgXmbDrawString = dlsym(handle, "XmbDrawString");
    OrgXwcDrawString = dlsym(handle, "XwcDrawString");
    OrgXmbDrawImageString = dlsym(handle, "XmbDrawImageString");
    OrgXwcDrawImageString = dlsym(handle, "XwcDrawImageString");
}
